Object.defineProperty(exports, '__esModule', { value: true });
const require_transform = require('./transform-DAhty8Ql.cjs');
const require_utils = require('./utils-B3bAMlp-.cjs');
const __babel_parser = require_transform.__toESM(require("@babel/parser"));
const __babel_plugin_syntax_jsx = require_transform.__toESM(require("@babel/plugin-syntax-jsx"));

//#region src/index.ts
const SyntaxJSX = __babel_plugin_syntax_jsx.default.default || __babel_plugin_syntax_jsx.default;
var src_default = () => {
	return {
		name: "Vue JSX Vapor",
		inherits: SyntaxJSX,
		visitor: {
			JSXElement: require_transform.transformJSX,
			JSXFragment: require_transform.transformJSX,
			Program: {
				enter: (path, state) => {
					state.importSet = /* @__PURE__ */ new Set();
					state.delegateEventSet = /* @__PURE__ */ new Set();
					state.preambleMap = /* @__PURE__ */ new Map();
					state.preambleIndex = 0;
					state.roots = [];
					const collectRoot = (path$1) => {
						if (!require_utils.isJSXElement(path$1.parent) && !require_utils.isConditionalExpression(path$1.parentPath)) state.roots.push({
							node: path$1.node,
							source: path$1.getSource(),
							inVaporComponent: !state.opts.interop ? true : path$1.findParent(({ node }) => node.type === "CallExpression" && node.callee.type === "Identifier" && ["defineVaporComponent", "defineComponent"].includes(node.callee.name))?.node.callee.name === "defineVaporComponent"
						});
					};
					path.traverse({
						JSXElement: collectRoot,
						JSXFragment: collectRoot
					});
				},
				exit: (path, state) => {
					const { delegateEventSet, importSet, preambleMap } = state;
					const statements = [];
					if (delegateEventSet.size) statements.unshift(`_delegateEvents(${Array.from(delegateEventSet).join(", ")});`);
					if (preambleMap.size) {
						let preambleResult = "";
						for (const [value, key] of preambleMap) preambleResult += `const ${key} = ${value}\n`;
						statements.unshift(preambleResult);
					}
					const helpers = ["setNodes", "createNodes"].filter((helper) => {
						const result = importSet.has(helper);
						result && importSet.delete(helper);
						return result;
					});
					if (helpers.length) statements.unshift(`import { ${helpers.map((i) => `${i} as _${i}`).join(", ")} } from 'vue-jsx-vapor/runtime';\n`);
					if (importSet.size) {
						const importResult = Array.from(importSet).map((i) => `${i} as _${i}`).join(", ");
						statements.unshift(`import { ${importResult} } from 'vue';\n`);
					}
					path.node.body.unshift(...(0, __babel_parser.parse)(statements.join("\n"), {
						sourceType: "module",
						plugins: ["typescript"]
					}).program.body);
				}
			}
		}
	};
};

//#endregion
exports.default = src_default;